/*-----------------------------------------------------------------------------
	Paper Plane xUI Module Junkyard									(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#define UNICODE
#include <windows.h>
// TOROWIN.H, PPCOMMON.H  PPx ̃\[X痬p
#include "../../ppx/TOROWIN.H"
#include "../../ppx/PPCOMMON.H"
#undef EXTDLL
#define EXTDLL

UINT WM_PPXCOMMAND;

#define TIMER_COUNT 10
DWORD timer_value[TIMER_COUNT];

void ModuleShowWindow(HWND hWnd, PPXMCOMMANDSTRUCT *command, int cmdshow, const char *mes);
void ModuleFitWindowSize(HWND hWnd, PPXMCOMMANDSTRUCT *command);
void ShowMessage(PPXAPPINFOW *ppxa, const WCHAR *msg);

HANDLE hDwmapi = NULL, hUxtheme = NULL;

const WCHAR M1[] = L"explorer";
// C:\Windows\Resources\Themes\aero\aero.msstyles ̃\[XCMAPQ
const WCHAR M2[] = L"DarkMode_Explorer"; // Button / Edit / ScrollBar
const WCHAR M3[] = L"DarkMode_ItemsView"; // Header / ListView
const WCHAR M4[] = L"DarkMode_CFD"; // Combobox / Edit
const WCHAR M5[] = L"DarkMode_InfoPaneToolbar"; // Toolbar
const WCHAR M6[] = L"DarkModeNavbar"; // Rebar
// const WCHAR M4[] = L"DarkMode"; // ToolBar
// DarkModeNavbarComposited::Rebar
DefineWinAPI(HRESULT, DwmSetWindowAttribute, (HWND, DWORD, LPCVOID, DWORD));
DefineWinAPI(HRESULT, SetWindowTheme, (HWND, LPCWSTR name, LPCWSTR idlist));
DefineWinAPI(BOOL, ShouldAppsUseDarkMode, (void)); // 132
DefineWinAPI(BOOL, AllowDarkModeForWindow, (HWND, BOOL)); // 133
DefineWinAPI(BOOL, SetPreferredAppMode, (DWORD)); // 135
DefineWinAPI(void, FlushMenuTheme, (void)); // 136
DefineWinAPI(void, RefreshImmersiveColorPolicyState , (void)); // 104
#define GETDLLPROCN(handle, name, id) D ## name = (imp ## name)GetProcAddress(handle, MAKEINTRESOURCEA(id));

DefineWinAPI(int, NormalizeString, (int, LPCWSTR, int, LPWSTR, int));

#if !defined(ES_CONTINUOUS) || defined(__GNUC__)
#undef ES_SYSTEM_REQUIRED
#undef ES_CONTINUOUS
#define ES_SYSTEM_REQUIRED  ((DWORD)1)
#define ES_DISPLAY_REQUIRED  ((DWORD)2)
#define ES_CONTINUOUS       ((DWORD)0x80000000)
typedef DWORD EXECUTION_STATE;
#endif

const WCHAR *DrawFormats[] = { // Lډ\ȃR}h͂U܂
	L"\"DUMMY\",8,1 - ",
	NULL
};

#pragma argsused
BOOL CALLBACK EnumDarkFixProc(HWND hWnd, LPARAM lParam)
{
	BOOL mode = TRUE;
	WCHAR text[300];

	DAllowDarkModeForWindow(hWnd, TRUE);

	if ( GetClassName(hWnd, text, 300) > 0 ){
		if ( wcscmp(text, L"ReBarWindow32") == 0 ){
			DSetWindowTheme(hWnd, M6, NULL);
		}else if ( wcscmp(text, L"ToolbarWindow32") == 0 ){
			DSetWindowTheme(hWnd, M5, NULL);
		}else if ( wcscmp(text, L"Edit") == 0 ){
			DSetWindowTheme(hWnd, M4, NULL);
		}else if ( wcscmp(text, L"SysHeader32") == 0 ){
			DSetWindowTheme(hWnd, M3, NULL);
		}else {
			DSetWindowTheme(hWnd, M2, NULL);
		}
	}else{
		DSetWindowTheme(hWnd, M4, NULL);
		DSetWindowTheme(hWnd, M3, NULL);
		DSetWindowTheme(hWnd, M2, NULL);
		DSetWindowTheme(hWnd, M5, NULL);
		DSetWindowTheme(hWnd, M6, NULL);
	}
	DDwmSetWindowAttribute(hWnd, 19, &mode, sizeof(mode));
/*
	TreeView:
	(void)TreeView_SetTextColor(hTWnd, CC_tree[0]);
	(void)TreeView_SetBkColor(hTWnd, CC_tree[1]);

	Edit
		case WM_CTLCOLOREDIT:
		WM_CTLCOLORDLG
*/
	return TRUE;
}

#define K_USERTIMERJ 0x3900
#pragma argsused
VOID CALLBACK UserTimerProc(HWND hWnd, UINT msg, UINT_PTR id, DWORD time)
{
	PostMessage(hWnd, WM_PPXCOMMAND, (id - TIMERID_TIMERMODULE) + K_USERTIMERJ, 0);
/*
	WCHAR *funcparam[2], label[16], param[CMDLINESIZE];

	wsprintfW(label, L"timer%d", id - TIMERID_TIMERMODULE);
	funcparam[0] = label;
	funcparam[1] = param;
*/
//	PPxInfoFunc(ppxa, PPXCMDID_GETWNDVARIABLEDATA, &funcparam);
}

typedef struct {
	WCHAR *name;
	int (*func)(PPXAPPINFOW *ppxa, PPXMODULEPARAM pxs, DWORD funcID);
	DWORD funcID;
} CMDLIST;

int PPx_GetFunc(PPXAPPINFOW *ppxa, PPXMODULEPARAM pxs, DWORD funcID)
{
	DWORD Value;

	PPxInfoFunc(ppxa, funcID, &Value);
	wsprintfW(pxs.command->resultstring, L"%d", Value);
	return PPXMRESULT_DONE;
}

#define DEFINEGETFUNCLIST(name, funcID) L#name, PPx_GetFunc, funcID
const CMDLIST get_funcs[] = {
	{DEFINEGETFUNCLIST(WindowDirection, PPXCMDID_WINDOWDIR)},
	{DEFINEGETFUNCLIST(DirectoryType, PPXCMDID_DIRTYPE)},
	{DEFINEGETFUNCLIST(SyncView, PPXCMDID_SYNCVIEW)},
	{DEFINEGETFUNCLIST(SlowMode, PPXCMDID_SLOWMODE)},
	{DEFINEGETFUNCLIST(EntryAllCount, PPXCMDID_DIRTOTAL)},
	{DEFINEGETFUNCLIST(EntryDisplayCount, PPXCMDID_DIRTTOTAL)},
	{DEFINEGETFUNCLIST(EntryDisplayTop, PPXCMDID_CSRDINDEX)},
	{DEFINEGETFUNCLIST(EntryDisplayX, PPXCMDID_CSRDISPW)},
	{DEFINEGETFUNCLIST(EntryDisplayY, PPXCMDID_CSRDISPH)},
	{DEFINEGETFUNCLIST(EntryMarkCount, PPXCMDID_DIRMARKS)},
	{DEFINEGETFUNCLIST(EntryDisplayFiles, PPXCMDID_DIRTTOTALFILE)},
	{DEFINEGETFUNCLIST(EntryDisplayDirectories, PPXCMDID_DIRTTOTALDIR)},
	{DEFINEGETFUNCLIST(EntryIndex, PPXCMDID_CSRINDEX)},
	{DEFINEGETFUNCLIST(EntryMark, PPXCMDID_CSRMARK)},
	{DEFINEGETFUNCLIST(EntryAttributes, PPXCMDID_CSRATTR)},
	{DEFINEGETFUNCLIST(EntryExtColor, PPXCMDID_CSREXTCOLOR)},
	{DEFINEGETFUNCLIST(EntryFirstMark, PPXCMDID_CSRMARKFIRST)},
	{DEFINEGETFUNCLIST(EntryNextMark, PPXCMDID_CSRMARKNEXT)},
	{DEFINEGETFUNCLIST(EntryPrevMark, PPXCMDID_CSRMARKPREV)},
	{DEFINEGETFUNCLIST(EntryLastMark, PPXCMDID_CSRMARKLAST)},
	{NULL, NULL, 0}
};

int PPx_SetFunc(PPXAPPINFOW *ppxa, PPXMODULEPARAM pxs, DWORD funcID)
{
	const WCHAR *param = pxs.command->param;
	DWORD Value;

	Value = _wtoi(param);
	PPxInfoFunc(ppxa, funcID, &Value);
	return PPXMRESULT_DONE;
}

#define DEFINEPUTFUNCLIST(name, funcID) L#name, PPx_SetFunc, funcID
const CMDLIST set_funcs[] = {
	{DEFINEPUTFUNCLIST(SyncView, PPXCMDID_SETSYNCVIEW)},
	{DEFINEPUTFUNCLIST(SlowMode, PPXCMDID_SETSLOWMODE)},
	{DEFINEPUTFUNCLIST(EntryDisplayTop, PPXCMDID_CSRSETDINDEX)},
	{DEFINEPUTFUNCLIST(EntryIndex, PPXCMDID_CSRSETINDEX)},
	{DEFINEPUTFUNCLIST(EntryMark, PPXCMDID_CSRSETMARK)},
	{DEFINEPUTFUNCLIST(EntryExtColor, PPXCMDID_CSRSETEXTCOLOR)},
	{NULL, NULL, 0}
};

void ShowMessage(PPXAPPINFOW* ppxa, const WCHAR* msg)
{
	if ( ppxa->Function(ppxa, PPXCMDID_MESSAGE, (void*)msg) != PPXA_NO_ERROR ){
		MessageBoxW(NULL, msg, NULL, MB_OK);
	}
}

void ParamCheck(PPXAPPINFOW* ppxa, PPXMODULEPARAM pxs)
{
	WCHAR textbuf[0x20000], *dest = textbuf;
	DWORD i;
	const WCHAR *param = pxs.command->param;

	dest += wsprintf(dest,
		L"CommandName: %s (0x%x)\n"
		L"Params: %d",
		pxs.command->commandname,
		pxs.command->commandhash,
		pxs.command->paramcount);

	for ( i = 1 ; i <= pxs.command->paramcount ; i++ ){
		dest += wsprintf(dest, L"\nParam[%d]: ", i);
		wcscpy(dest, param);
		dest += wcslen(dest);
		param += wcslen(param) + 1;
	}

	ShowMessage(ppxa, textbuf);
}

void RawParam(PPXAPPINFOW *ppxa)
{
	BSTR param;

	param = (BSTR)PPxInfoFunc(ppxa, PPXCMDID_GETRAWPARAM, NULL);
	if ( param != NULL ){
		ShowMessage(ppxa, param);
		SysFreeString(param);
	}
}

#define xNormalizationC 1
#define xNormalizationD 2
#define xNormalizationKC 5
#define xNormalizationKD 6

void NormalizeText(PPXAPPINFOW *ppxa, PPXMODULEPARAM pxs, int norm)
{
	int len = wcslen(pxs.command->param) * 3;
	WCHAR *text;

	GETDLLPROC(GetModuleHandleW(L"KERNEL32.dll"), NormalizeString);
	if ( DNormalizeString == NULL ) return;
	text = malloc(len * sizeof(WCHAR));
	if ( text != NULL ){
		DNormalizeString(norm, pxs.command->param, -1, text, len);

		SetLongResult(ppxa, pxs, text);
		free(text);
	}
}

const CLSID CLSID_CommonQuery = {0x83bc5ec0, 0x6f2a, 0x11d0, {0xa1, 0xc4, 0x0, 0xaa, 0x00, 0xc1, 0x6e, 0x65}};
const GUID IID_ICommonQuery = {0xab50dec0, 0x6f1d, 0x11d0, {0xa1, 0xc4, 0x0, 0xaa, 0x00, 0xc1, 0x6e, 0x65}};
const CLSID CLSID_DsQuery = {0x8a23e65e, 0x31c2, 0x11d0, {0x89, 0x1c, 0x0, 0xa0, 0x24, 0xab, 0x2d, 0xbb}};

const CLSID DsFind[] = {
	/*const CLSID CLSID_DsFindObjects =*/ {0x83ee3fe1, 0x57d9, 0x11d0, {0xb9, 0x32, 0x0, 0xa0, 0x24, 0xab, 0x2d, 0xbb}}, // object
	/*const CLSID CLSID_DsFindPeople =*/ {0x83ee3fe2, 0x57d9, 0x11d0, {0xb9, 0x32, 0x0, 0xa0, 0x24, 0xab, 0x2d, 0xbb}}, // people
	/*const CLSID CLSID_DsFindPrinter =*/ {0xb577f070, 0x7ee2, 0x11d0, {0x91, 0x3f, 0x0, 0xaa, 0x0, 0xc1, 0x6e, 0x65}}, // printer
	/*const CLSID CLSID_DsFindComputer =*/ {0x16006700, 0x87ad, 0x11d0, {0x91, 0x40, 0x0, 0xaa, 0x0, 0xc1, 0x6e, 0x65}}, // computer
	/*const CLSID CLSID_DsFindVolume =*/ {0xc1b3cbf1, 0x886a, 0x11d0, {0x91, 0x40, 0x0, 0xaa, 0x0, 0xc1, 0x6e, 0x65}}, // folder
	/*const CLSID CLSID_DsFindContainer =*/ {0xc1b3cbf2, 0x886a, 0x11d0, {0x91, 0x40, 0x0, 0xaa, 0x0, 0xc1, 0x6e, 0x65}}, // container
	/*const CLSID CLSID_DsFindAdvanced =*/ {0x83ee3fe3, 0x57d9, 0x11d0, {0xb9, 0x32, 0x0, 0xa0, 0x24, 0xab, 0x2d, 0xbb}}, // custom
	/*const CLSID CLSID_DsFindDomainController=*/ {0x538c7b7e, 0xd25e, 0x11d0, {0x97, 0x42, 0x0, 0xa0, 0xc9, 0x6, 0xaf, 0x45}}, // dc
	/*const CLSID  CLSID_DsFindWriteableDomainController=*/ {0x7cbef079, 0xaa84, 0x444b, {0xbc, 0x70, 0x68, 0xe4, 0x12, 0x83, 0xea, 0xbc}}, // wdc
	/*const CLSID  CLSID_DsFindFrsMembers=*/ {0x94ce4b18, 0xb3d3, 0x11d1, {0xb9, 0xb4, 0x0, 0xc0, 0x4f, 0xd8, 0xd5, 0xb0}} // frs
};
const WCHAR *FormTypes[] = {
	L"object", L"people", L"printer", L"computer",
	L"folder", L"container", L"custom", L"dc", L"wdc", L"frs",
	NULL
};

typedef struct
{
	DWORD cbStruct;
	DWORD dwFlags;
	LPWSTR pDefaultScope;
	LPWSTR pDefaultSaveLocation;
	LPWSTR pUserName;
	LPWSTR pPassword;
	LPWSTR pServer;
} DSQUERYINITPARAMS;

typedef struct
{
	DWORD cbStruct;
	DWORD dwFlags;
	CLSID clsidHandler;
	LPVOID pHandlerParameters;
	CLSID clsidDefaultForm;
	/*IPersistQuery*/ void *pPersistQuery;
	union {
		void *pFormParameters;
		// IPropertyBag *ppbFormParameters;
	};
} OPENQUERYWINDOW;

#undef INTERFACE
#define INTERFACE ICommonQuery
DECLARE_INTERFACE_(ICommonQuery, IUnknown)
{
	// IUnknown
	STDMETHOD (QueryInterface)(THIS_ REFIID riid, void **ppv) PURE;
	STDMETHOD_(ULONG, AddRef)(THIS) PURE;
	STDMETHOD_(ULONG, Release)(THIS) PURE;

	// ICommonQuery
	STDMETHOD(OpenQueryWindow)(THIS_ HWND hwndParent, OPENQUERYWINDOW *pQueryWnd, IDataObject** ppDataObject) PURE;
};

#define OQWF_OKCANCEL 1
#define OQWF_DEFAULTFORM 2
#define OQWF_SINGLESELECT 4
#define OQWF_SHOWOPTIONAL 0x80
#define DSQPF_SHOWHIDDENOBJECTS 4
#define DSQPF_ENABLEADMINFEATURES 8
#define DSQPF_ENABLEADVANCEDFEATURES 0x10
#define CFSTR_DSOBJECTNAMES L"DsObjectNames"

typedef struct
{
	DWORD dwFlags;
	DWORD dwProviderFlags;
	DWORD offsetName;
	DWORD offsetClass;
} DSOBJECT, * LPDSOBJECT;

typedef struct
{
	CLSID clsidNamespace;
	UINT cItems;
	DSOBJECT aObjects[1];
} DSOBJECTNAMES;


int QueryDirectoryService(PPXAPPINFOW *ppxa, PPXMODULEPARAM pxs)
{
	HRESULT hr;
	ICommonQuery *pcq;
	int result = PPXMRESULT_STOP;

	hr = CoCreateInstance(&CLSID_CommonQuery, NULL, CLSCTX_INPROC_SERVER,
		&IID_ICommonQuery, (LPVOID*)&pcq);
	if ( SUCCEEDED(hr) ){
		OPENQUERYWINDOW openQueryWindow;
		DSQUERYINITPARAMS dqip;
		IDataObject *pdo;
		int mode = 3, index = 0;
		const WCHAR **types;

		for ( types = FormTypes; *types != NULL; types++, index++){
			if ( strcmpW(pxs.command->param, *types) == 0 ){
				mode = index;
				break;
			}
		}

		memset(&openQueryWindow, 0, sizeof(openQueryWindow));
		openQueryWindow.cbStruct = sizeof(openQueryWindow);
		openQueryWindow.dwFlags = OQWF_OKCANCEL | OQWF_DEFAULTFORM | OQWF_SINGLESELECT | OQWF_SHOWOPTIONAL;
		openQueryWindow.pHandlerParameters = &dqip;
		openQueryWindow.clsidHandler = CLSID_DsQuery;
		openQueryWindow.clsidDefaultForm = DsFind[mode];

		memset(&dqip, 0, sizeof(dqip));
		dqip.cbStruct = sizeof(dqip);
		dqip.dwFlags = DSQPF_SHOWHIDDENOBJECTS | DSQPF_ENABLEADMINFEATURES | DSQPF_ENABLEADVANCEDFEATURES;
		hr = pcq->lpVtbl->OpenQueryWindow(pcq, ppxa->hWnd, &openQueryWindow, &pdo);
		if ( hr == S_OK ){
			FORMATETC fmtetc;
			STGMEDIUM medium;

			fmtetc.cfFormat = (CLIPFORMAT)RegisterClipboardFormatW(CFSTR_DSOBJECTNAMES);
			fmtetc.ptd = NULL;
			fmtetc.dwAspect = DVASPECT_CONTENT;
			fmtetc.lindex = -1;
			fmtetc.tymed = TYMED_HGLOBAL;
			if ( SUCCEEDED(pdo->lpVtbl->GetData(pdo,&fmtetc, &medium)) ){
				DSOBJECTNAMES *objname;
				WCHAR *name, *ptr, *user = L"";

				objname = (DSOBJECTNAMES *)GlobalLock(UNIONNAME0(medium, hGlobal));

				if ( objname->cItems > 0 ){
					name = ((LPWSTR)(char *)((char *)objname + objname->aObjects[0].offsetName));
					// LDAP://dname1.dname2/CN=Users,CN=Builtin,DC=dname1,DC=dname2
					if ( mode == 3 ){
						if ( name[6] == '/' ) name += 7;
						ptr = strstrW(name, L"/CN=");
						if ( ptr != NULL ){
							*ptr = '\0';
							user = ptr + 4;
							ptr = strchrW(user, ',');
							if ( ptr != NULL ) *ptr = '\0';
						}
						wsprintfW(pxs.command->resultstring, L"\\\\%s.%s", user, name);
					}else{
						wsprintfW(pxs.command->resultstring, L"%s", name);
					}
					result = PPXMRESULT_DONE;
				}
				GlobalUnlock(UNIONNAME0(medium, hGlobal));
				ReleaseStgMedium(&medium);
			}
			pdo->lpVtbl->Release(pdo);
		}
		pcq->lpVtbl->Release(pcq);
	}
	return result;
}

/*-----------------------------------------------------------------------------
	dll ̏^I
-----------------------------------------------------------------------------*/
#pragma argsused
BOOL WINAPI DllEntry(HINSTANCE hInst, DWORD reason, LPVOID reserved)
{
	return TRUE;
}

/*-----------------------------------------------------------------------------
	{
-----------------------------------------------------------------------------*/
int PPXAPI ModuleEntry(PPXAPPINFOW *ppxa, DWORD cmdID, PPXMODULEPARAM pxs)
{
	WCHAR buf[200];

	if ( cmdID == PPXMEVENT_FILEDRAW ){ // pxs.draw L ====================
		switch ( pxs.draw->commandhash ){ // *commandhash œl
			case 0xc33413cb: // BLANK
				return PPXMRESULT_DONE; // Ȃ̂ŁA̍sŕ`ec
		}
		return PPXMRESULT_SKIP;
	}

	if ( cmdID == PPXMEVENT_COMMAND ){ // =====================================
		if ( !wcscmp(pxs.command->commandname, L"DARKMODE") ){
		/*
			_[NH
				uxtheme.dll
				132(RS5)			ShouldAppsUseDarkMode(BOOL)

			j[_[N
				uxtheme.dll
				135(RS5)			AllowDarkModeForApp(BOOL)
				135(19H1)			SetPreferredAppMode(DWORD)
					0: 1:DarkOnDark 2:DarkMode
			^Cgo[_[N
				dwmapi.dll
		*/
			DWORD mode = 1;
			HWND hParentWnd;

			hParentWnd = ppxa->hWnd;
			while ( GetParent(hParentWnd) != NULL ){
				hParentWnd = GetParent(hParentWnd);
			}

			if ( hDwmapi == NULL ){
				hDwmapi = LoadLibraryW(L"dwmapi.dll");
//				hDwmapi = GetModuleHandleW(L"dwmapi.dll");
				GETDLLPROC(hDwmapi, DwmSetWindowAttribute);
				DDwmSetWindowAttribute(hParentWnd, 19, &mode, sizeof(mode));

				hUxtheme = LoadLibraryW(L"uxtheme.dll");
				GETDLLPROC(hUxtheme, SetWindowTheme);
				GETDLLPROCN(hUxtheme, ShouldAppsUseDarkMode, 132);
				GETDLLPROCN(hUxtheme, AllowDarkModeForWindow, 133);
				GETDLLPROCN(hUxtheme, SetPreferredAppMode, 135);
				GETDLLPROCN(hUxtheme, FlushMenuTheme, 136);
			}
			DShouldAppsUseDarkMode(); // H
			DSetPreferredAppMode(2); // j[ωAj[o[͕ωȂ
			DFlushMenuTheme(); // ω𔽉f
			EnumChildWindows(hParentWnd, EnumDarkFixProc, (LPARAM)ppxa);
			return PPXMRESULT_DONE;
		}
		// ====================================================================
		/*
			^C}[s *settimer id, time
				id: 09 ̔CӒl
				time: Ԋu(ms)
				o^ƁAtime Ԋu Kx_main  V_H390x ͂

		*/
		if ( !wcscmp(pxs.command->commandname, L"SETTIMER") ){
			if ( pxs.command->paramcount >= 1 ){
				int id, time;
				const WCHAR *param = pxs.command->param;

				id = _wtoi(param);
				if ( (id < 0) || (id > 0xf) ) return PPXMRESULT_STOP;
				if ( pxs.command->paramcount >= 2 ){
//					WCHAR *funcparam[2], label[16];

					param += wcslen(param) + 1;
					time = _wtoi(param);
/*
					wsprintfW(label, L"timer%d", id);
					funcparam[0] = label;
					funcparam[1] = wcslen(param) + 1;
					PPxInfoFunc(ppxa, PPXCMDID_SETWNDVARIABLEDATA, &funcparam);
*/
					WM_PPXCOMMAND = RegisterWindowMessageA(PPXCOMMAND_WM);
					SetTimer(ppxa->hWnd, id + TIMERID_TIMERMODULE, time, UserTimerProc);
				}else{
					KillTimer(ppxa->hWnd, id + TIMERID_TIMERMODULE);
				}
			}
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"VER") ){
			WCHAR buf[200];
			OSVERSIONINFO OSver;	// OS 
			DWORD PPxVer;

			PPxVer = PPxInfoFunc(ppxa, PPXCMDID_VERSION, NULL);

			OSver.dwOSVersionInfoSize = sizeof(OSver);
			GetVersionEx(&OSver);
			wsprintf(buf, L"Windows Version %d.%d.%d %s(PlatformId=%x)\n"
					L"PPx Version %d+%d(Unicode=%d)",
				OSver.dwMajorVersion, OSver.dwMinorVersion,
				OSver.dwBuildNumber,
				OSver.szCSDVersion,
				OSver.dwPlatformId,
				PPxVer / 100, PPxVer % 100,
				PPxInfoFunc(ppxa, PPXCMDID_CHARTYPE, NULL) );
			ShowMessage(ppxa, buf);
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"SIGINT") ){
			int pid;

			pid = _wtoi(pxs.command->param);
			if ( pid > 0 ){
				GenerateConsoleCtrlEvent(CTRL_C_EVENT, (DWORD)pid);
			}
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"SIGBREAK") ){
			int pid;

			pid = _wtoi(pxs.command->param);
			if ( pid > 0 ){
				GenerateConsoleCtrlEvent(CTRL_BREAK_EVENT, (DWORD)pid);
			}
			return PPXMRESULT_DONE;
		}

		// ====================================================================
		if ( !wcscmp(pxs.command->commandname, L"MSGBOX2") ){
			MessageW(pxs.command->param);
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"LOG") ){
			PPxInfoFunc(ppxa, PPXCMDID_DEBUGLOG, (void *)pxs.command->param);
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"REPORT") ){
			PPxInfoFunc(ppxa, PPXCMDID_REPORTTEXT, (void *)pxs.command->param);
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"PARAM") ){
			ParamCheck(ppxa, pxs);
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"RAWPARAM") ){
			RawParam(ppxa);
			return PPXMRESULT_DONE;
		}

		// 32bit ̃t@CVXe_CNg̗LύX
		// XbhP
		if ( !wcscmp(pxs.command->commandname, L"FSREDIRECT") ){
			DefineWinAPI(BOOL, Wow64EnableWow64FsRedirection, (BOOL));
			GETDLLPROC(GetModuleHandleW(L"KERNEL32.dll"), Wow64EnableWow64FsRedirection);

			if ( DWow64EnableWow64FsRedirection != NULL ){
				DWow64EnableWow64FsRedirection(_wtoi(pxs.command->param));
			}
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"STARTTIME") ){
			int id;

			id = _wtoi(pxs.command->param);
			if ( (id < 0) || (id >= TIMER_COUNT) ) id = 0;
			timer_value[id] = GetTickCount();
			return PPXMRESULT_DONE;
		}
		// ====================================================================
		if ( !wcscmp(pxs.command->commandname, L"KEEPWAKE") ){
			DefineWinAPI(EXECUTION_STATE, SetThreadExecutionState, (EXECUTION_STATE));

			GETDLLPROC(GetModuleHandleW(L"KERNEL32.dll"), SetThreadExecutionState);
			DSetThreadExecutionState(ES_SYSTEM_REQUIRED | ES_CONTINUOUS);
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"KEEPDISPLAY") ){
			DefineWinAPI(EXECUTION_STATE, SetThreadExecutionState, (EXECUTION_STATE));

			GETDLLPROC(GetModuleHandleW(L"KERNEL32.dll"), SetThreadExecutionState);
			DSetThreadExecutionState(ES_DISPLAY_REQUIRED | ES_CONTINUOUS);
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"KEEPOFF") ){
			DefineWinAPI(EXECUTION_STATE, SetThreadExecutionState, (EXECUTION_STATE));

			GETDLLPROC(GetModuleHandleW(L"KERNEL32.dll"), SetThreadExecutionState);
			DSetThreadExecutionState(0);
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"ENDTIME") ){
			int id, delta;

			id = _wtoi(pxs.command->param);
			if ( (id < 0) || (id >= TIMER_COUNT) ) id = 0;
			delta = GetTickCount() - timer_value[id];
			if ( delta < 0 ) delta = -delta;
			wsprintfW(buf, L"TIME #%d  %02d:%02d:%02d.%03d", id,
					 delta / 60 / 60 / 1000,
					 (delta / 60 / 1000) % 60,
					 (delta / 1000) % 60,
					 delta % 1000);
			PPxInfoFunc(ppxa, PPXCMDID_SETPOPLINE, buf);
			ShowMessage(ppxa, buf);
			return PPXMRESULT_DONE;
		}

		// *loop "*set aab=%%*calc(%%'aab'+1) %%: *linemessage %%'aab' %%: *stop %%'aab' >= 20"
		if ( !wcscmp(pxs.command->commandname, L"LOOP") ){
			ERRORCODE resultcode;

			for (;;){
				resultcode = PPxInfoFunc(ppxa, PPXCMDID_EXECUTE, (void *)pxs.command->param);
				if ( resultcode != 1 ) break;
			}
			return PPXMRESULT_DONE;
		}

		{
			const CMDLIST *funclist = set_funcs;
			for (;;){
				if ( !_wcsicmp(pxs.command->commandname, funclist->name) ){
					return funclist->func(ppxa, pxs, funclist->funcID);
				}
				funclist++;
				if ( funclist->funcID == 0 ) break;
			}
		}
		return PPXMRESULT_SKIP;
	}
	if ( cmdID == PPXMEVENT_FUNCTION ){ //=====================================
		if ( !wcscmp(pxs.command->commandname, L"ENDTIME")){
			int id, delta;

			id = _wtoi(pxs.command->param);
			if ( (id < 0) || (id >= TIMER_COUNT) ) id = 0;
			delta = GetTickCount() - timer_value[id];
			if ( delta < 0 ) delta = -delta;
			wsprintfW(pxs.command->resultstring, L"%d", delta);
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"PARAM") ){
			ParamCheck(ppxa, pxs);
			wcscpy(pxs.command->resultstring, L"dummy");
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"RAWPARAM") ){
			RawParam(ppxa);
			wcscpy(pxs.command->resultstring, L"dummy");
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"LENW")){
			wsprintf(pxs.command->resultstring, L"%d", wcslen(pxs.command->param));
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"LENA")){
			wsprintf(pxs.command->resultstring, L"%d", WideCharToMultiByte(CP_ACP, 0, pxs.command->param, -1, NULL, 0, NULL,NULL) - 1);
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"LEN8")){
			wsprintf(pxs.command->resultstring, L"%d", WideCharToMultiByte(CP_UTF8, 0, pxs.command->param, -1, NULL, 0, NULL,NULL) - 1);
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"LONGTEXT")){
			int len;
			WCHAR *text;

			len = _wtoi(pxs.command->param);
			if ( (len < 0) || (len >= 0x70000000) ) len = 10;
			text = malloc((len + 100) * sizeof(WCHAR));
			if ( text != NULL ){
				int offset;

				offset = wsprintfW(text, L"%d: 123ABCabc", len);
				if ( len <= offset ){
					offset = len;
				}else{
					WCHAR c = L'a';

					len--;
					for(;;){
						if ( offset >= len ) break;
						text[offset++] = c++;
						if ( c > L'z' ) c = 'a';
					}
					text[offset++] = '$';
				}
				text[offset] = '\0';
				SetLongResult(ppxa, pxs, text);
				free(text);
			}
			return PPXMRESULT_DONE;
		}

		if ( !wcscmp(pxs.command->commandname, L"NORMALIZE")){
			NormalizeText(ppxa, pxs, xNormalizationC);
			return PPXMRESULT_DONE;
		}
		if ( !wcscmp(pxs.command->commandname, L"NORMALIZENFD")){
			NormalizeText(ppxa, pxs, xNormalizationD);
			return PPXMRESULT_DONE;
		}
		if ( !wcscmp(pxs.command->commandname, L"NORMALIZENFKC")){
			NormalizeText(ppxa, pxs, xNormalizationKC);
			return PPXMRESULT_DONE;
		}
		if ( !wcscmp(pxs.command->commandname, L"NORMALIZENFKD")){
			NormalizeText(ppxa, pxs, xNormalizationKD);
			return PPXMRESULT_DONE;
		}
		if ( !wcscmp(pxs.command->commandname, L"QUERYDIRECTORY")){
			return QueryDirectoryService(ppxa, pxs);
		}

		{
			const CMDLIST *funclist = get_funcs;
			for (;;){
				if ( !_wcsicmp(pxs.command->commandname, funclist->name) ){
					return funclist->func(ppxa, pxs, funclist->funcID);
				}
				funclist++;
				if ( funclist->funcID == 0 ) break;
			}
		}
		return PPXMRESULT_SKIP;
	}
	if ( cmdID == PPXMEVENT_FILEDRAWINFO ){ // pxs == NULL ====================
		const WCHAR **formats;

		for ( formats = DrawFormats ; *formats != NULL ; formats++ ){
			PPxInfoFunc(ppxa, PPXCMDID_REPORTPPCCOLUMN, (void *)*formats);
		}
		return PPXMRESULT_SKIP; // K PPXMRESULT_SKIP
	}

	if ( cmdID == PPXM_INFORMATION ){ // ======================================
		if ( pxs.info->infotype == 0 ){
			pxs.info->typeflags =
					PPMTYPEFLAGS(PPXM_INFORMATION) |
					PPMTYPEFLAGS(PPXMEVENT_COMMAND) |
					PPMTYPEFLAGS(PPXMEVENT_FUNCTION) |
					PPMTYPEFLAGS(PPXMEVENT_FILEDRAW) |
					PPMTYPEFLAGS(PPXMEVENT_FILEDRAWINFO);
			wcscpy(pxs.info->copyright, L"PPx Module Junk parts R4 (" T(__DATE__) L") Copyright (c)TORO");
			return PPXMRESULT_DONE;
		}
	}
	return PPXMRESULT_SKIP;
}
